/*=============================================================================
 *
 *  Filename:      VMatObj.hpp
 *  Version:            1.0
 *  Date:								06/11/96
 *  Author:             B.G.
 *
 *  Description:    editor material class
 *
 *===========================================================================*/

#ifndef __VMATOBJ_HPP__
#define __VMATOBJ_HPP__

/******************************************/
#if _MSC_VER >= 1000
#pragma once
#endif
/******************************************/

#include <afxtempl.h>
#include <afxcview.h>

#include "Acp_base.h"
#include "itf.h"
#include "gmt.h"
#include "scr.h"


class tdoEditorVisualMaterial : public CPA_SaveObject
{
public:
	tdoEditorVisualMaterial(
		CPA_FileObject *_p_oOwnerFile,
		CString _csId,
		BOOL _bSectionAlreadyExists,
		ACP_tdxHandleOfMaterial _hTemplateVisualMaterial
	);
	~tdoEditorVisualMaterial();

	ACP_tdxHandleOfMaterial m_hGetEngineMaterial() { return m_hVisualMaterial; }
	static void m_vCallBackSaveVMT( // save the visual material section
		SCR_tdst_File_Description *_p_stFile,
		char *_p_szSectionName,
		void *_p_vData,
		SCR_tde_Ntfy_Action _eAction
	);
	BOOL m_bIsReferenced();

	static CString m_csGetMaterialType();
	static CString m_csGetScriptExtension();

	//overloads from base class
	virtual void *GetData(void) { return m_hVisualMaterial; }
  virtual long GetDataType(void) { return 0; };
  virtual tdeMissingCriteria fn_eCheckUnicity(const CString csNewName) { return fn_eCheckUnicityWithOwner(csNewName); }

	//virtual void fn_vNotify(SCR_tde_Ntfy_Action _eAction);
	//CString GetReferencedSectionName(void);

private:
	ACP_tdxHandleOfMaterial m_hVisualMaterial;
};

#endif /* __VMATOBJ_HPP__ */
